"use strict";
// Теоретичні питання
//
// Описати своїми словами навіщо потрібні функції у програмуванні.
//     Описати своїми словами, навіщо у функцію передавати аргумент.
//     Що таке оператор return та як він працює всередині функції?
//
//     Завдання
//     Реалізувати функцію, яка виконуватиме математичні операції з введеними користувачем числами. Завдання має бути виконане на чистому Javascript без використання бібліотек типу jQuery або React.
//
//     Технічні вимоги:
//
//     Отримати за допомогою модального вікна браузера два числа.
//     Отримати за допомогою модального вікна браузера математичну операцію, яку потрібно виконати. Сюди може бути введено +, -, *, /.
//     Створити функцію, в яку передати два значення та операцію.
//     Вивести у консоль результат виконання функції.
//     Необов'язкове завдання підвищеної складності
//     Після введення даних додати перевірку їхньої коректності. Якщо користувач не ввів числа, або при вводі вказав не числа, - запитати обидва числа знову (при цьому значенням за замовчуванням для кожної зі змінних має бути введена інформація раніше).
//
//
// Література: https://learn.javascript.ru/function-basics
// 1. функції потрібні для використання одного коду у різних місцях програми
// 2. Це не обов'язково. Але якщо нам потрібно від функції отримати дії над якимось даними, якими функція не володіє
//          сама пособі потрібно передбачити отримання їх ззовні, для цього потрібен аргумент, або кілька.
// 3."return" потрібен для виведення результату роботи функції назовні, тобто повернути значення
/***************************************************************************************/
function validation(message) {
    let num                                //для перевірки будемо використовувати функцію з минулого завдання,
    for (; ;) {                          //але замість перевірки на ціле число Number.isInteger()
        num = +prompt(message);         // перевірятимемо просто на число Number.isFinite ().
        if (Number.isFinite (num)) {
            break
        } else alert('введене значення не є числом');
    }
    return num;
}
const mathAction = {                             //Створимо об'єкт властивостями якого є арифметичні дії,
    '+': function(a, b) { return a + b; },       //а значеннями цих властивостей будуть відповідні функції (методи)
    '-': function(a, b) { return a - b; },      //які повертатимуть результат операції в результаті звернення
    '*': function(a, b) { return a * b; },
    '/': function(a, b) { return a / b; }
};
function mathAction2(a, b, d) {    //другий варіант з допомогою switch
    switch (d) {
        case '+' :
            return a + b;
        case '/' :
            return a / b;
        case '-' :
            return a - b;
        case '*' :
            return a * b;
    }
}
/*****************************************************************************************/
let num1 = validation('Введіть перше число')     //валідуємо
let c = prompt('введіть арифметичну дію') //питаємо яку операцію хоче зробити користувач
let num2 = validation('Введіть друге число')      //знову валідуємо
                                                                   //звертаємось до нашого об'єкта
console.log(`${num1} ${c} ${num2} = ${mathAction[c](num1, num2)} - метод об'єкта`);   //підставляючи опитані значення
                                                                      //виводимо шукане в консоль

console.log(`${num1} ${c} ${num2} = ${mathAction2(num1, num2, c)} - switch`);





